"""Courses.
"""
import grok
from zope.interface import implementedBy
from zope.component.interfaces import IFactory
from waeup.interfaces import ICourse

class Course(grok.Model):
    grok.implements(ICourse)

    def __init__(self,
                 title=u'Unnamed Course',
                 code=u'NA', **kw):
        super(Course, self).__init__(**kw)
        self.title = title
        self.code = code
        
class CourseFactory(grok.GlobalUtility):
    """A factory for courses.
    """
    grok.implements(IFactory)
    grok.name(u'waeup.Course')
    title = u"Create a new course.",
    description = u"This factory instantiates new course instances."

    def __call__(self):
        return Course()

    def getInterfaces(self):
        return implementedBy(Course)
